<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>

<head>
  <title>Festo SBO Configuration</title>
  <link rel="stylesheet" media="screen" type="text/css" href="festo-config.css">
  <link rel="SHORTCUT ICON" href="festo.ico">
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
</head>

<body>

<?php
  $readvalues = array (
          'ip' => '',
          'netmask' => '',
          'dns' => '',
          'gateway' => '',
          'dhcp' => '',
          'hostname' => '',
          'domain' => '',
          'confirm' => ''
        );

  // get current values
  $pathIp="/proc/config/ip";
  $handleIp=fopen($pathIp, "r");
  $readvalues['ip']=trim(fread($handleIp, 15));
  fclose($handleIp);

  $pathHostname="/proc/config/hostname";
  $handleHostname=fopen($pathHostname, "r");
  $readvalues['hostname']=trim(fread($handleHostname, 40));
  fclose($handleHostname);

  $pathGateway="/proc/config/gateway";
  $handleGateway=fopen($pathGateway, "r");
  $readvalues['gateway']=trim(fread($handleGateway, 15));
  fclose($handleGateway);

  $pathNetmask="/proc/config/netmask";
  $handleNetmask=fopen($pathNetmask, "r");
  $readvalues['netmask']=trim(fread($handleNetmask, 15));
  fclose($handleNetmask);

  $pathDNS="/proc/config/dns";
  $handleDNS=fopen($pathDNS, "r");
  $readvalues['dns']=trim(fread($handleDNS, 15));
  fclose($handleDNS);

  $pathDhcp="/proc/config/dhcp";
  $handleDhcp=fopen($pathDhcp, "r");
  $readvalues['dhcp']=trim(fread($handleDhcp, 1));
  fclose($handleDhcp);

  $newvalues = $readvalues;

  function IpStyleCheck ($value)
  {
    $valuelength=strlen($value);

    if($valuelength == 0)
      return (0);

    $pattern="([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3})";
    if (ereg($pattern, $value, $regs))
      if ($valuelength==strlen($regs[1]))
        return (1);
    else
        return (0);
  }

  function NameStyleCheck ($value)
  {
    $valuelength=strlen($value);

    if($valuelength == 0)
      return (0);

    $pattern="[0-9|a-z|A-Z|_-]{{$valuelength}}";
      if (ereg($pattern, $value))
        return (1);
      else
        return (0);
  }

  $error_message = "";

  if(isset($_REQUEST['action']))
  {
    if($_REQUEST['action'] == "netsettings")
      {
        $fconfiginput = array (
          'ip' => '\n',
          'mac' => '\n',
          'netmask' => '\n',
          'dns' => '\n',
          'gateway' => '\n',
          'dhcp' => '\n',
          'hostname' => '\n',
          'domain' => '\n',
          'confirm' => 'yes\n'
        );

        $password_ok = false;
        if(isset($_REQUEST['password']))
        {
          $enc_response = shell_exec("./crypt " . $_REQUEST['password']);
          $handle=fopen("/proc/config/password", "r");
          $stored=trim(fread($handle, 50));
          fclose($handle);

          if($stored == $enc_response)
            $password_ok = true;
        }

        $reloadIP = $readvalues['ip'];

        $update = false;

        $error_hostname=false;
        $error_dns=false;
        $error_gateway=false;
        $error_netmask=false;
        $error_dhcp=false;
        $error_mac=false;

        $value = trim($_REQUEST['hostname']);
        if($value != $readvalues['hostname'])
          {
            $newvalues['hostname'] = $value;
            if(NameStyleCheck($value))
              {
                $fconfiginput['hostname'] = $value . '\n';
                $update = true;
              }
            else
              {
                $error_hostname=true;
              }
            }

        $value = trim($_REQUEST['dns']);
        if($value != $readvalues['dns'])
          {
            $newvalues['dns'] = $value;
            if(IpStyleCheck($value))
              {
                $fconfiginput['dns'] = $value . '\n';
                $update = true;
              }
            else
              {
                $error_dns=true;
              }
            }

        $value = trim($_REQUEST['ip']);
        if($value != $readvalues['ip'])
          {
            $newvalues['ip'] = $value;
            if(IpStyleCheck($value))
              {
                $fconfiginput['ip'] = $value . '\n';
                $update = true;
                $reloadIP = $newvalues['ip'];
              }
            else
              {
                $error_ip=true;
              }
            }

        $value = trim($_REQUEST['netmask']);
        if($value != $readvalues['netmask'])
          {
            $newvalues['netmask'] = $value;
            if(IpStyleCheck($value))
              {
                $fconfiginput['netmask'] = $value . '\n';
                $update = true;
              }
            else
              {
                $error_netmask=true;
              }
            }

        $value = trim($_REQUEST['gateway']);
        if($value != $readvalues['gateway'])
          {
            $newvalues['gateway'] = $value;
            if(IpStyleCheck($value))
              {
                $fconfiginput['gateway'] = $value . '\n';
                $update = true;
              }
            else
              {
                $error_gateway=true;
              }
            }

        $value = trim($_REQUEST['dhcp']);
        if($value != $readvalues['dhcp'])
          {
            $newvalues['dhcp'] = $value;
            if(($value == "0" || $value == "1"))
              {
                $fconfiginput['dhcp'] = $value . '\n';
                $update = true;
                if($value == "1")
                  {
                    $reloadIP="dhcp";
                  }
              }
            else
              {
                $error_dhcp=true;
              }
            }

        if($password_ok == false)
          $error_message = $error_message . "Password invalid. <br/>";

        if($error_hostname == true)
          $error_message = $error_message . "Hostname not valid. <br/>";

        if($error_dns == true)
          $error_message = $error_message . "DNS ip address not valid. <br/>";

        if($error_netmask == true)
          $error_message = $error_message . "Netmask address not valid. <br/>";

        if($error_subnet == true)
          $error_message = $error_message . "Subnet address not valid. <br/>";

        if($error_gateway == true)
          $error_message = $error_message . "Gateway address not valid. <br/>";

        if($error_dhcp == true)
          $error_message = $error_message . "DHCP value not valid. <br/>";

        if($error_message == "" && $update == true && $password_ok == true)
        {

          $commandline = "echo -ne \"" . implode("", $fconfiginput) . "\" | fconfig" ;
          // echo $commandline;
          $response = shell_exec($commandline);
          shell_exec("echo 1 > /proc/config/refresh");
          // echo $response;
        }
        else
          $reponse = "";
      }
  }
?>
  <div>
    <form action="?action=netsettings" method="POST">
      <table style="margin: 0px auto; width: 700px;">

        <tr>
          <td class="conf-right">Hostname:</td>
          <td class="conf-left"><input class="conf-input" type="text" size="30"
                value="<?php echo $newvalues['hostname']; ?>" name="hostname" /></td>
        </tr>

        <tr>
          <td colspan="2" class="conf-spacer"></td>
        </tr>

        <tr>
          <td class="conf-right">IP address:</td>
          <td class="conf-left"><input class="conf-input" type="text" size="16" maxlength="15"
                     value="<?php echo $newvalues['ip']; ?>" name="ip" /></td>
        </tr>

        <tr>
          <td colspan="2" class="conf-spacer"></td>
        </tr>

        <tr>
          <td class="conf-right">Netmask:</td>
          <td class="conf-left"><input class="conf-input" type="text" size="16" maxlength="15"
                     value="<?php echo $newvalues['netmask']; ?>" name="netmask" /></td>
        </tr>

      <tr>
        <td colspan="2" class="conf-spacer"></td>
      </tr>

      <tr>
        <td class="conf-right">Gateway:</td>
        <td class="conf-left"><input class="conf-input" type="text" size="16" maxlength="15"
                 value="<?php echo $newvalues['gateway']; ?>" name="gateway" /></td>
      </tr>

       <tr>
        <td colspan="2" class="conf-spacer"></td>
      </tr>

      <tr>
        <td class="conf-right">Domain Name Server:</td>
        <td class="conf-left"><input class="conf-input" type="text" size="16" maxlength="15"
                 value="<?php echo $newvalues['dns']; ?>" name="dns" /></td>
      </tr>

       <tr>
        <td colspan="2" class="conf-spacer"></td>
      </tr>

        <tr>
            <td class="conf-right">DHCP:</td>
            <td class="conf-left">

            <input type="radio" name="dhcp" value="0" <?php if($newvalues['dhcp'] == "0") echo "checked"; ?> > disabled </input>
            <input type="radio" name="dhcp" value="1" <?php if($newvalues['dhcp'] == "1") echo "checked"; ?> > enabled </input>
        </tr>
         <tr>
          <td colspan="2" class="conf-spacer"></td>
        </tr>
        <tr>
          <td colspan="2" class="conf-spacer"></td>
        </tr>
<?php
  if($error_message != "")
  {
  echo <<<END
         <tr>
          <td colspan="2" class="conferror">$error_message</td>
        </tr>
        <tr>
          <td colspan="2" class="conf-spacer"></td>
        </tr>
END;
  }
?>

 <?php
  if($response != "")
  {
  echo <<<END
         <tr>
           <td colspan="2" class="conf-reboot">settings stored. <br>
           you need to <a href="./reboot.php?reload=$reloadIP">reboot</a> the camera that the changes take effect.</td>
        </tr>
        <tr>
          <td colspan="2" class="conf-spacer"></td>
        </tr>
END;
  }
?>
      <tr>
          <td colspan="2" style="text-align: right;">
            Please confirm changes with the device password:
            <input class="conf-input" type="password" size="15" name="password" />
            <input class="conf-submit" type="submit" id="submit" value="submit" />
          </td>
        </tr>
        </table>
        </form>
    </div>

</body>
</html>

